/*Ŀ
 ݳ                                                                      
 ݳ Program Name: TEST.PRG          Copyright: Oregon Dept. Of Revenue   
 ݳ Date Created: 11/05/95           Language: Clipper 5.0               
 ݳ Time Created: 08:52:43             Author: Kevin S Gallagher         
 Ĵ
 ݳ Shows simple yet attractive redefining of several characters so that 
 ݳ boxs can appear like those found in Norton Utilities for DOS. There  
 ݳ are two different types of Norton boxs, one that does not allow you  
 ݳ to place titles on the box top line and one that does.               
 ݳ                                                                      
 ݳ alert() function in myalert.prg flips between 2 modes that is done   
 ݳ be checking who the calling routine is. I would use a SetGet type of 
 ݳ function and incorp it into your errorsystem so that it's more       
 ݳ generic then how i did it here. BTW the TMR code has been tested in  
 ݳ REAL mode for CA-Clipper 5.2c/e and 5.3                              
 ݳ                                                                      
 ݳ Caveat: I included a method to show how EMM386.EXE has been setup    
 ݳ (must be using DOS five or greater). This can be done with a call    
 ݳ to a function such as ft_Int86() in nanforum library also.           
 
            */

#define MC          maxcol() +1

#define B_LINE      REPLICATE(CHR(200)

#define	N_SINGLE    (CHR(218) + CHR(196) + CHR(191) + CHR(127) +    ;
                     CHR(224) + CHR(203) + CHR(192) + CHR(179) + " ")

#define	N_LOWBOX    (CHR(160) + CHR(161) + CHR(162) + CHR(127) +    ;
                     CHR(224) + CHR(203) + CHR(192) + CHR(179) + " ")


#define A_EMSARRAY                                                  ;
    {                                                               ;
        {"EMMQXXX0","EMM386 installed with NOEMS"}                 ,;
        {"EMMXXXX0","EMS available for Clipper to use"}            ,;
        {"$MMXXXX0","EMS Memory not available"}                     ;
    }

procedure main
    local nTr      := 0
    local nTc      := 0
    local nBc      := maxcol()
    local lBlink   := setblink(.f.)
    local cVersion := os()

    cls

    // redefine some characters for thin boxs
    kg_init()
    
    dispbox(0,0,10,maxcol(),N_SINGLE,"w+/b")
    @nTr,nTc   SAY PADC("Nortons type of boxes",MC)          COLOR "B/W+*"
    @nTr,nTc   SAY CHR(213)                                  COLOR "W+/N"
	@nTr,nTc+1 SAY CHR(214)                                  COLOR "W+/N"
	@nTr,nTc+2 SAY CHR(179)                                  COLOR "N/W+*"
    @nTr+3,nTc SAY CHR(195) + B_LINE,(nBc-nTc)-1) + CHR(181) COLOR "W+/B"

    // This box type has a lowered top to it for titles
    dispbox(5,6,8,40,N_LOWBOX,"n/b")
    
    @5,8 say " Lower me top "                                COLOR "GR+/B"

    if "DOS" $ cVersion .and. val(strtran(cVersion,"DOS","")) >= 5
        aeval(A_EMSARRAY,                                               ;
            { |aArr_|                                                   ;
                if( file(aArr_[1])                                     ,;
                    eval({|x| devpos(7,8),devout(x,"w+/b")},aArr_[2])  ,;
                );
            };
        )

        Alert("Alert starting on row;16",{"OK","Not OK","Maybe","Never"},16,"W+/+B,N/G")
    else
        alert("You should update your DOS!",,16,"W+/+B,N/G")
    endif

    cls

    alert("the next alert box should appear with the default;" +;
          "lines used instead of thin lines. This is for showing;" +;
          "you that the alert function can work in two modes;" +;
          "Get rid for a runtime error to test it out.",,,"w+/rb,w+/n",.t.;
    )

    setblink(lBlink)
    //
    // OKay since we made a call to Setmode the redefined characters
    // can no longer be used.
    //
    ?val(0)
    //
    // If there were no errors then we need to reset the redefined 
    // characters using setmode.
    //
    setmode(25)
    quit
return

/*
*   Routine: kg_init
*          : 
*   Purpose: wrapper for David Tessitore's C-code for redefining any ascii
*          : characters which i use for TMR look ala Norton Utilities.
*          : 
* Arguments: void
*          : 
*  Comments: locals were used to keep code on the screen
*          : 
*/
procedure kg_init
    local x1 :=   0
    local x2 :=   1
    local x3 :=   8
    local x4 :=  16
    local x5 := 128
    local x6 := 143
    local x7 := 241
    local x8 := 255

    //         +-- character to redefine
    //         |     +-- array to make new pixel pattern for specified char
    //         |     |
    KG_Chars( 127, {x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2} )
    KG_Chars( 224, {x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x8} )
    KG_Chars( 179, {x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5} )
    KG_Chars( 181, {x2,x2,x2,x2,x2,x2,x2,x8,x2,x2,x2,x2,x2,x2,x2,x2} )
    KG_Chars( 191, {x8,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2,x2} )
    KG_Chars( 192, {x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x8} )
    KG_Chars( 195, {x5,x5,x5,x5,x5,x5,x5,x8,x5,x5,x5,x5,x5,x5,x5,x5} )
    KG_Chars( 196, {x8,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1} )
    KG_Chars( 200, {x1,x1,x1,x1,x1,x1,x1,x8,x1,x1,x1,x1,x1,x1,x1,x1} )
    KG_Chars( 203, {x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x1,x8} )
    KG_Chars( 209, {x8,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4} )
    KG_Chars( 210, {x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4,x4} )
    KG_Chars( 211, {x4,x4,x4,x4,x4,x4,x4,x8,x1,x1,x1,x1,x1,x1,x1,x1} )
    KG_Chars( 212, {x4,x4,x4,x4,x4,x4,x4,x8,x4,x4,x4,x4,x4,x4,x4,x4} )
    KG_Chars( 213, {x8,x5,x5,x5,x5,x5,x6,x6,x5,x5,x5,x5,x5,x5,x5,x8} )
    KG_Chars( 214, {x8,x2,x2,x2,x2,x2,x7,x7,x2,x2,x2,x2,x2,x2,x2,x8} )
    KG_Chars( 218, {x8,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5,x5} )
    // below are for the lowered top tin box
    KG_Chars( 160, {x1,x1,x1,x1,x1,x1,x8,x5,x5,x5,x5,x5,x5,x5,x5,x5} )
    KG_Chars( 161, {x1,x1,x1,x1,x1,x1,x8,x1,x1,x1,x1,x1,x1,x1,x1,x1} )
    KG_Chars( 162, {x1,x1,x1,x1,x1,x1,x8,x2,x2,x2,x2,x2,x2,x2,x2,x2} )
    
return
